Subject: Re: mii-tool gigabit support.

From: Auke Kok <[email-masked]>
Date: Wed, 27 Sep 2006 11:42:56 -0700

Maciej W. Rozycki wrote:
> On Wed, 27 Sep 2006, Rick Jones wrote:
> 
>>> Another scenario: forcing the NIC to negotiate only full-duplex speeds. Not
>>> only fun if you try it against a hub, but possibly useful.
> [...]
>> I'm just worried (as in Fear Uncertainty and Doubt) that having people set the
>> allowed things to negotiate isn't really any more robust than stright-up
>> hardcodes and perpetuates the (IMO) myth that one shouldn't autoneg on general
>> principle.
> 
>  Older equipment, which may still be in use here and there, allowed 
> full-duplex operation, but no auto-negotiation.  The duplex setting was 
> either fixed or selectable in a system-specific manner.  In such a case 
> you certainly want your modern other end to be forced to full-duplex, but 
> still let it detect the link speed, so that you do not have to do 
> reconfiguration whenever you move a link between a 10base-T and a 
> 100base-Tx port.

in this case the new addition to ethtool will not help as it only changes the 
modes that the NIC will advertise. In this specific case you will need to turn 
of advertising/autonegotiation and force a speed/duplex pair anyway.

Advertising all half-duplex modes to a partner that does not do autonegotiation 
is (by spec I think) an unsupported configuration (i.e. undetermined behaviour).

That's nothing new.

Auke